function [out] = prfilter(in)
% discrete time filter implementation
% implemented with non complex numbers (as will be in Verilog)
% RPOLES    : real poles
% RRES      : real residues
% CPOLESre  : real part of complex poles
% CPOLESim  : imag  ''         ''    ''
% CRESre    : real part of complex residues
% CRESim    : imag  ''         ''    ''
% X         : real states
% Xr        : real part of complex states
% Xi        : imag   ''        ''    ''
global RPOLES CPOLESre CPOLESim RRES CRESre CRESim X Xr Xi;

  
  out = dot(X,RRES) + in;
  out = out + 2*(dot(CRESre, Xr) - dot(CRESim, Xi) );

  X = RPOLES.*X + in;

  Xr = CPOLESre.*Xr - CPOLESim.*Xi + in;
  Xi = CPOLESim.*Xr + CPOLESre.*Xi;



